image = './tiffs/landscape_d800e_Output.tiff';
image = './tiffs/_MG_0895_Output.tiff';
image = './pngs/window.png';
image = './pngs/fence.png';

fprintf('the demo only handles RGGB\n');

addpath('./mex/nn_src');
addpath('./mex/lsd_src');
addpath('./mex/zw_src');
addpath('./modif/matlab_scripts');

I = double(imread(image));
cols = size(I, 2);
rows = size(I, 1);

if ~isempty(findstr(image, '.tiff'))
fprintf('scale the image to 8 bit format\n');
% scale to the usual range [0, 255]
I = I / (2^16-1) * (2^8-1);
rows = min(rows, 5e3);
cols = min(cols, 5e3);
I = I(1:rows, 1:cols, 1:3);
end

% demosaick using neural networks
nn_mex(I(:), rows, cols);
fprintf('nn ends.\n');

% zhangwu demosaicking
zw_mex('mosaiced.png');
fprintf('zhangwu ends.\n');

% run lsd on zw restored image
I = double(rgb2gray(imread('dmzw.png')));
lsdEdgeList = lsd_mex(I, 0.8, 0.6);
edges{1} = lsdEdgeList(2,:);
edges{2} = lsdEdgeList(4,:);
edges{3} = lsdEdgeList(1,:);
edges{4} = lsdEdgeList(3,:);
[edgemap,~,~] = visualise_edges(I,edges,cell(1,4));

imwrite(uint8(edgemap(3:end-2, 3:end-2)* 250), 'line.png');

% convolve edge map with a block to fatten the detected edges
fat = 4;
s = 2*fat + 1;
edgemap = conv2(edgemap, ones(s,s));
edgemap = edgemap(s-fat:end-fat, s-fat:end-fat);
edgemap = edgemap(3:end-2, 3:end-2);
edgemap(edgemap > 0) = 1;

imwrite(uint8(edgemap * 250), 'fat_line.png');

% combine
zwdm = imread('dmzw.png');
zwdm = zwdm(3:end-2, 3:end-2, 1:3);
nndm = imread('dmnn.png');

mosaic = imread('mosaiced.png');
mosaic = mosaic(3:end-2, 3:end-2, 1:3);
imwrite(mosaic, 'mosaiced.png');

r = double(zwdm(:, :, 1)) .* edgemap + double(nndm(:, :, 1)) .* (1-edgemap);
g = double(zwdm(:, :, 2)) .* edgemap + double(nndm(:, :, 2)) .* (1-edgemap);
b = double(zwdm(:, :, 3)) .* edgemap + double(nndm(:, :, 3)) .* (1-edgemap);
c = cat(3, r, g, b);

imwrite(zwdm, 'dmzw.png');
imwrite(uint8(c), 'combo.png');
